#include "myarea.h"
#include <gtkmm/application.h>
#include <gtkmm/window.h>
#include <gtkmm/button.h>
#include <gtkmm/box.h>

class AnimWindow : public Gtk::Window {
public:
	AnimWindow();
	virtual ~AnimWindow() {}

protected:
	void reset();

	Gtk::Box packer;
	MyArea area;
	Gtk::Button reset_button;
};

AnimWindow::AnimWindow(){
	packer = Gtk::Box(Gtk::ORIENTATION_VERTICAL);
	packer.set_homogeneous(false);
	set_title("Animation Window");
	set_default_size(1000, 1000);
	reset_button.add_label("Reset");
	reset_button.signal_clicked().connect(sigc::mem_fun(*this, &AnimWindow::reset));
	add(packer);
	packer.pack_start(reset_button, false, false);
	reset_button.show();
	packer.pack_start(area, true, true);
	area.show();
	packer.show();
}

void AnimWindow::reset(){
	area.bounce();
}

int main(int argc, char** argv)
{
	auto app = Gtk::Application::create(argc, argv, "org.gtkmm.example");
	AnimWindow win;
	return app->run(win);
}
