#ifndef GTKMM_EXAMPLE_MYAREA_H
#define GTKMM_EXAMPLE_MYAREA_H

#include <gtkmm/drawingarea.h>
#include <vector>
#include <cstdlib>

class AnimObject;

class MyArea : public Gtk::DrawingArea
{
public:
	MyArea();
	virtual ~MyArea();
	int time;
	void bounce();

protected:
	const int resolution = 1;
	std::vector<AnimObject*> objects;
	bool down;
	bool on_draw(const Cairo::RefPtr<Cairo::Context>& cr) override;
	bool on_timeout();
	void update_all(int, int);
	void draw_all(const Cairo::RefPtr<Cairo::Context>& cr);
	void init_objects();
};

class AnimObject {
public:	
	bool mover;
	float xv, yv;
	float x, y, r;
	AnimObject() : x(0), y(0), mover(false) {}
	AnimObject(int ix, int iy, int ir) : x(ix), y(iy), r(ir) {}
	virtual void update(float time, int width, int height) = 0;
	virtual void draw(const Cairo::RefPtr<Cairo::Context>& cr) = 0;
	virtual void collide(AnimObject *other) = 0;
	virtual void back_up() = 0;
};

#define GRAVITY 0.01
class Ball : public AnimObject {
	float lx, ly;
public:
	Ball(int ix, int iy, int ir);
	Ball(int ix, int iy, int ir, float ixv, float iyv);
	void update(float time, int width, int height);
	void draw(const Cairo::RefPtr<Cairo::Context>& cr);
	void collide(AnimObject *other);
	void back_up();
};

#endif // GTKMM_EXAMPLE_MYAREA_H
